<template>
  <div :id="id"></div>
  <!-- <div v-if="charData.length" :id="id"></div> -->
  <!-- <div v-else class="chart--nodata"></div> -->
</template>

<script>
// import G2 from '@antv/g2';
import * as G2 from '@antv/g2';
export default {
  data() {
    return {
      chart: null
    };
  },
  props: {
    charData: {
      type: Array,
      default() {
        return [];
      }
    },
    id: String,
    width: {
      type: Number,
      default: 1192
    }
  },
  mounted() {
    setTimeout(() => {
      this.drawChart(); // 第一步是创建的时候更新图表，但是这个不适用于异步请求接口获取相关数据，采用下面的监听的方式
    }, 30);
  },
  beforeUpdate() {
    this.drawChart();
  },
  watch: {
    charData() {
      this.drawChart();
    }
  },
  methods: {
    async drawChart() {
      this.chart && this.chart.destroy();
      this.chart = new G2.Chart({
        container: this.id,
        height: 359,
        forceFit: true,
        width: this.width,
        padding: [20, 40, 80, 80]
      });
      this.chart.data(this.charData);
      // 图例
      this.chart.legend({
        custom: true,
        position: 'top-left',
        items: [
          { name: '今日添加人数', value: 'addNum', marker: { symbol: 'line', style: { stroke: '#4B74E8', lineWidth: 12, lineHeight: 8 } } },
          { name: '今日点击人次', value: 'clickTimes', marker: { symbol: 'line', style: { stroke: '#D6B38C', lineWidth: 12, lineHeight: 8 } } },
          { name: '今日点击人数', value: 'clickNum', marker: { symbol: 'line', style: { stroke: '#14C9C9', lineWidth: 12, lineHeight: 8 } } }
        ]
      });
      this.chart.tooltip({
        showCrosshairs: true,
        shared: true,
        itemTpl: `<div style="margin-bottom: 10px;list-style:none;">
            <span style="background-color:{color};" class="g2-tooltip-marker"></span>
            {name}: {value}
            </div>`
      });

      this.chart
        .line()
        .position('bizDate*addNum')
        .color('#4B74E8')
        .tooltip('addNum', addNum => {
          return {
            name: '今日添加人数',
            value: addNum
          };
        });

      this.chart
        .line()
        .position('bizDate*clickTimes')
        .tooltip('clickTimes', clickTimes => {
          return { name: '今日点击人次', value: clickTimes };
        })
        .color('#D6B38C');
      this.chart
        .line()
        .position('bizDate*clickNum')
        .tooltip('clickNum', clickNum => {
          return { name: '今日点击人数', value: clickNum };
        })
        .color('#14C9C9');

      this.chart.removeInteraction('legend-filter'); // 自定义图例，移除默认的分类图例筛选交互
      //图表绘制的最后一步，用于将图表渲染至画布
      this.chart.render();
    }
  }
};
</script>
